<?php
//
// database.php
//
// Module for managing MySQL database tables
//
// CopyRight (c) 2003 Xiaohui Li
//

// shared database variables
$hostname = "localhost";

// database internal variables
$refCount = 0;
$connection = 0;

function db_open($host, $db, $user, $passwd)
{
    global $refCount;
    global $connection;
    if (!$refCount)
    {
        $connection = mysql_connect($host, $user, $passwd);
        if ($connection)
        {
            if (!(mysql_select_db($db, $connection)))
                $connection = 0;
        }
    }
    if ($connection)
        $refCount++;
    return $connection;
}

function db_close()
{
    global $refCount;
    global $connection;
    $refCount--;
    if ($refCount == 0)
    {
        mysql_close($connection);
    }
}

// this function tests if current user has write access to the database
function db_writeaccess()
{
    global $connection;
    if (!mysql_query("create table dummy (test CHAR(1));"))
        return 0;
    mysql_query("drop table dummy;");
    return 1;
}

function urlClean($input, $maxLength)
{
    $input = substr($input, 0, $maxLength);
    $input = EscapeShellCmd($input);
    return $input;
}

function showError()
{
    die ("MySQL Database Error " . mysql_errno() . ": " . mysql_error());
}

function isWildcardFirst($pattern)
{
    if ($pattern) {
        if (($pattern{0} == '*') || ($pattern{0} == '?'))
            return 1;
    }
    return 0;
}

function wildcardReplace($query)
{
    if (strstr($query, '*')) {
        $rep = " LIKE '";
        $rep .= str_replace('*', '%', $query) . "';";
    }
    else if (strstr($query, '?')) {
        $rep = " LIKE '";
        $rep .= str_replace('?', '_', $query) . "';";
    }
    else {
        $rep = "='$query';";
    }
    return $rep;
}

function isDateValid($date)
{
    if (!ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $regs))
        return 0;
    if (($regs[1] < 1900) || ($regs[1] > 2200) ||
        ($regs[2] < 1) || ($regs[2] > 12) ||
        ($regs[3] < 1) || ($regs[3] > 31))
        return 0;
    return 1;
}

function isUidValid($uid)
{
    return !ereg("[^0-9*?.]", $uid);
}

?>
