<?php
//
// manipulate.php
//
// Module for manipulating images
//
// CopyRight (c) 2003 Xiaohui Li
//
session_start();

#if (!extension_loaded('php_imagick'))
#    dl ('php_imagick.' . PHP_SHLIB_SUFFIX);

include 'database.php';
include 'security.php';

?>
<html>
<head><title>PacsOne Server - Image Processing</title></head>
<body>

<?
require 'header.php';

if (isset($_POST['path']))
	$path = urldecode($_POST['path']);
else
    $path = $_SESSION['imagePath'];
// gather image information
$handle = imagick_readimage($path);
if (imagick_iserror($handle))
{
    $reason = imagick_failedreason($handle);
    $description = imagick_faileddescription($handle);
    print "handle failed!<BR>\nReason: $reason<BR>\nDescription: $description<BR>\n" ;
    exit;
}
$width = imagick_getwidth($handle);
$height = imagick_getheight($handle);
imagick_destroyhandle($handle);
// image processing menu
$imagedir = "images";
print "<table width=100% border=0 cellspacing=2 cellpadding=0>\n";
$file = basename($path);
$path = urlencode($path);
// display the converted image
print "<tr><td>\n";
print "<P><IMG SRC='nocache.php?path=$path' BORDER='0' ALIGN='middle'><P>\n";
print "</td></tr>\n";
// image processing table
print "<tr><td><table width=100% border=1 cellspacing=0 cellpadding=0>\n";
// window/level control
print "<tr><form method='POST' action='windowLevel.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Window/Level</b></td>\n";
print "<td>\n";
print "Image pixel grayscale values range from 0 (darkest) to 100 (brightest)<br>";
print "Window size: ";  // window control
print "<input type=text maxlength=3 name='window' value='100'>from 1 to 100<br>\n";
print "Level: ";        // level control
print "<input type=text maxlength=2 name='level' value='50'>from 0 to 100<br>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Window/Level' title='Display Processed Image'>\n";
print "</td>\n";
print "</form></tr>\n";
// gamma control
print "<tr><form method='POST' action='gamma.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Gamma Correction</b></td>\n";
print "<td>Gamma correction value: ";
print "<input type=text maxlength=4 name='gamma' value='1.5'> typical range from 0.8 to 2.3</input><br>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Gamma' title='Gamma Correction'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// image contrast
print "<tr><form method='POST' action='contrast.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Contrast</b></td>\n";
print "<td>\n";
print "<input type=radio name='contrast' value='1' checked>Increase</input><br>\n";
print "<input type=radio name='contrast' value='0'>Decrease</input>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Contrast' title='Image Contrast'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// edge enhancement
print "<tr><form method='POST' action='edge.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Edge Enhancement</b></td>\n";
print "<td>Select radius from 1 to 10 pixels: ";
print "<input type=text maxlength=2 name='radius' value='2'></input>";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Enhance' title='Edge Enhancement'>\n";
print "</td>\n";
print "</form></tr>\n";
// resize image
print "<tr><form method='POST' action='resize.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Resize Image</b></td>\n";
print "<td>\n";
print "<input type=radio name='zoom' value='0' checked>\n";
print "Width: <input type=text maxlength=3 name='width' value='$width'></input>\n";
print "Height: <input type=text maxlength=3 name='height' value='$height'></input><br>\n";
print "</input>\n";
print "<input type=radio name='zoom' value='2'>2x Zoom</input>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Resize' title='Resize Image'>\n";
print "</td>\n";
print "</form></tr>\n";
// image enhancement
print "<tr><form method='POST' action='enhance.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Enhance Image</b></td>\n";
print "<td>Apply digital filtering to improve the quality of a noisy image</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Image Enhancement' title='Enhance Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// histogram equalization
print "<tr><form method='POST' action='equalize.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Equalize Image</b></td>\n";
print "<td>Apply histogram equalization to the image</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Equalize' title='Equalize Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// negate image
print "<tr><form method='POST' action='negate.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Negate Image</b></td>\n";
print "<td>\n";
print "<input type=radio name='negate' value='1' checked>Negate only grayscale values within the image</input><br>\n";
print "<input type=radio name='negate' value='0'>Negate all grayscale values</input>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Negate' title='Negate Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// normalize image
print "<tr><form method='POST' action='normalize.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Normalize Image</b></td>\n";
print "<td>Enhance contrast of images by normalizing pixel grayscale values</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Normalize' title='Normalize Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// image rotation
print "<tr><form method='POST' action='rotate.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Rotate Image</b></td>\n";
print "<td>\n";
print "Rotate ";
print "<input type=text maxlength=3 name='degree' value='90'> degrees</input><br>\n";
print "<input type=radio name='direction' value='1' checked>Clockwise<br>\n";
print "<input type=radio name='direction' value='-1'>Counter-clockwise<br>\n";
print "</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Rotate' title='Rotate Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// go back to the original image
print "<tr><form method='POST' action='originalImage.php'>\n";
print "<input type=hidden name='path' value=$path>\n";
print "<td><b>Original Image</b></td>\n";
print "<td>Display the stored original image</td>\n";
print "<td align=center>\n";
print "<input type=submit value='Original Image' title='Go Back To Original Image'>\n";
print "</input></td>\n";
print "</form></tr>\n";
// end of image processing table
print "</table>\n";

print "</table>\n";
?>
</body>
</html>

