<?php
//
// searchSeries.php
//
// Module for searching series information
//
// CopyRight (c) 2003 Xiaohui Li
//
session_start();

include 'database.php';
include 'security.php';
include 'display.php';

?>
<html>
<head>
<title>PacsOne Server - Series Search Results:</title>
</head>
<body>
<?
require 'header.php';

$uid = $_REQUEST['uid'];
$compare = $_REQUEST['compare'];
$date = $_REQUEST['date'];
$modality = $_REQUEST['modality'];

$database = $_SESSION['authenticatedDatabase'];
$username = $_SESSION['authenticatedUser'];
$password = $_SESSION['authenticatedPassword'];
db_open($hostname, $database, $username, $password);
$error = searchSeries($uid, $modality, $compare, $date);
if ($error) {
    print "<font color=red>$error</font>";
}
?>
</body>
</html>

<?
function searchSeries($uid, $modality, $compare, $date)
{
	$error = "";
    // check if UID format is valid
    if ($uid && !isUidValid($uid)) {
        return "Invalid UID";
    }
    // make sure first char of any search pattern is not a wild-card char
    if (isWildcardFirst($uid)) {
        return "First character of series UID search pattern cannot be " .
               "wild-card chars like '*' or '?'";
    }
    // check if valid date format
    if ($date && !isDateValid($date)) {
        return "Invalid DATE, please use YYYY-MM-DD format";
    }
    // build query string based on form input
    if ($uid) {
        $query = "SELECT * from series where uid";
        $query .= wildcardReplace($uid);
    } else if ($modality) {
        $query = "SELECT * from series where modality";
        $query .= wildcardReplace($modality);
    } else if ($date) {
        $query = "SELECT * from series where date ";
        if (strcasecmp($compare, "EQUAL") == 0) {
            $query .= "= '$date';";
        } else if (strcasecmp($compare, "BEFORE") == 0) {
            $query .= "< '$date';";
        } else if (strcasecmp($compare, "AFTER") == 0) {
            $query .= "> '$date';";
        } else {
            die ("Invalid Date Comparator: . $compare");
        }
    } else {
        $error = "<br>You must enter a criteria for ";
        $error .= "<a href='search.php'>Search By Series";
    }
    if (isset($query)) {
        $result = mysql_query($query);
        if ($result) {
            $num_rows = mysql_num_rows($result);
            displaySeries($result, "$num_rows matching series found in PACS database.");
        }
    }
    return $error;
}
?>
