<?php
//
// searchStudy.php
//
// Module for searching study information
//
// CopyRight (c) 2003 Xiaohui Li
//
session_start();

include 'database.php';
include 'security.php';
include 'display.php';

?>
<html>
<head>
<title>PacsOne Server - Study Search Results:</title>
</head>
<body>
<?
require 'header.php';

$uid = $_REQUEST['uid'];
$id = $_REQUEST['id'];
$compare = $_REQUEST['compare'];
$date = $_REQUEST['date'];
$accession = $_REQUEST['accession'];

$database = $_SESSION['authenticatedDatabase'];
$username = $_SESSION['authenticatedUser'];
$password = $_SESSION['authenticatedPassword'];
db_open($hostname, $database, $username, $password);
$error = searchStudy($uid, $id, $compare, $date, $accession);
if ($error) {
    print "<font color=red>$error</font>";
}
?>
</body>
</html>

<?
function searchStudy($uid, $id, $compare, $date, $accession)
{
	$error = "";
    // check if UID format is valid
    if ($uid && !isUidValid($uid)) {
        return "Invalid UID";
    }
    // make sure first char of any search pattern is not a wild-card char
    if (isWildcardFirst($id) || isWildcardFirst($uid)) {
        return "First character of study search pattern cannot be " .
               "wild-card chars like '*' or '?'";
    }
    // check if valid date format
    if ($date && !isDateValid($date)) {
        return "Invalid DATE, please use YYYY-MM-DD format";
    }
    // build query string based on form input
    if ($uid) {
        $query = "SELECT * from study where uid";
        $query .= wildcardReplace($uid);
    } else if ($id) {
        $query = "SELECT * from study where id";
        $query .= wildcardReplace($id);
    } else if ($date) {
        $query = "SELECT * from study where date ";
        if (strcasecmp($compare, "EQUAL") == 0) {
            $query .= "= '$date';";
        } else if (strcasecmp($compare, "BEFORE") == 0) {
            $query .= "< '$date';";
        } else if (strcasecmp($compare, "AFTER") == 0) {
            $query .= "> '$date';";
        } else {
            die ("Invalid Date Comparator: . $compare");
        }
    } else if ($accession) {
        $query = "SELECT * from study where accessionnum";
        $query .= wildcardReplace($accession);
    } else {
        $error = "<br>You must enter a criteria for ";
        $error .= "<a href='search.php'>Search By Study";
    }
    if (isset($query)) {
        $result = mysql_query($query);
        if ($result) {
            $num_rows = mysql_num_rows($result);
            displayStudies($result, "$num_rows matching studies found in PACS database.");
        }
    }
    return $error;
}
?>
