<?php
//
// windowLevel.php
//
// Module for adjusting window/level of displayed images
//
// CopyRight (c) 2003 Xiaohui Li
//
session_start();

#if (!extension_loaded('php_imagick'))
#    dl ('php_imagick.' . PHP_SHLIB_SUFFIX);

$path = urldecode($_POST['path']);
$window = $_POST['window'];
$level = $_POST['level'];
// update the image path of the image being processed
$_SESSION['imagePath'] = $path;
// validate the parameters
if ($window < 1 || $window > 100)
    $window = 100;
if ($level < 0 || $level > 100)
{
    $level = 50;
}
// translate window/level values into black/white scale control
$black = $level - $window / 2;
if ($black < 0)
    $black = 0;
$white = $level + $window / 2;
if ($white > 100)
    $white = 100;
$spec = $black . "%," . $white . "%,1.0";
// read the image
$handle = imagick_readimage($path);
if (imagick_iserror($handle))
{
    $reason = imagick_failedreason($handle);
    $description = imagick_faileddescription($handle);
    print "handle failed!<BR>\nReason: $reason<BR>\nDescription: $description<BR>\n" ;
    exit;
}
imagick_level($handle, $spec);
imagick_writeimage($handle, $path);

header('Cache-Control: no-cache');
header('Pragma: no-cache');
header('Location: manipulate.php');

?>

